connect to tlma%

create procedure ADM.DROP_IF_EXISTS(in NAME char(100))
	begin
	declare STMT char(250);
	declare MSG char(20);
	
	declare continue handler for sqlstate '42704' set MSG = 'ok';
	
	set STMT = 'DROP ' concat NAME;
	prepare S1 from STMT;
	execute S1;
end%
	
call ADM.DROP_IF_EXISTS('PROCEDURE ADM.RPRT_GEN')%     	
call ADM.DROP_IF_EXISTS('PROCEDURE ADM.RPRT_GAPS')%
call ADM.DROP_IF_EXISTS('TRIGGER ADM.RG_INSERT_T3')%     	

CREATE PROCEDURE ADM.RPRT_GEN()
  LANGUAGE SQL
  BEGIN ATOMIC
   
    FOR v AS cur1 CURSOR FOR 
                select id from adm.REPORT_GROUP where id not in (select DISTINCT REPORT_GROUP_id from adm.IBM_REPORT) and id > 1
    DO       
      INSERT INTO adm.IBM_REPORT (id, start_date, end_date, customer_id, version, report_group_id) values (
	(select LAST_ID +1  from adm.oid where table_name = 'adm.ibm_report'),
	(select date(value) from adm.control where name = 'DB_CREATION'),
	(select date(value) from adm.customer_control where name = 'LATEST_REPORT_GENERATION_DATE'),
	1,
	(select value from adm.control where name = 'DATABASE_VERSION'),
   	v.id);
   	
   update adm.oid set last_id = last_id +1 where table_name = 'adm.ibm_report';
   
    END FOR;
  END%
  
call ADM.RPRT_GEN%  

CREATE PROCEDURE ADM.RPRT_GAPS()
  LANGUAGE SQL
  BEGIN ATOMIC
   
    FOR v AS cur1 CURSOR FOR 
      select 
				distinct r.END_DATE,r.REPORT_GROUP_ID
			from 
				adm.IBM_REPORT r
			where 
				r.REPORT_GROUP_ID > 1
				and r.END_DATE < (select min(START_DATE) - 1 day from adm.IBM_REPORT r2 where r2.report_group_id = r.REPORT_GROUP_ID and r2.start_date > r.end_date)
    DO       
      INSERT INTO adm.IBM_REPORT (id, start_date, end_date, customer_id, version, report_group_id) values (
      (select LAST_ID +1  from adm.oid where table_name = 'adm.ibm_report'),
      (date(v.END_DATE + 1 day)),
      (select min(start_date) - 1 day from adm.ibm_report where REPORT_GROUP_ID = v.REPORT_GROUP_ID and START_DATE > v.END_DATE),
      1,
      (select value from adm.control where name = 'DATABASE_VERSION'),
      v.report_group_id);
           	
      update adm.oid set last_id = last_id +1 where table_name = 'adm.ibm_report';
   
    END FOR;
END%

call ADM.RPRT_GAPS%  

CREATE TRIGGER ADM.RG_INSERT_T3
AFTER INSERT ON ADM.REPORT_GROUP 
REFERENCING NEW AS N FOR EACH ROW MODE DB2SQL
if (date(n.creation_time) >= (select date(value) +1 day from adm.control where name = 'DB_CREATION') )
then
INSERT INTO adm.ibm_report
(
   id, start_date, end_date, customer_id, version, report_group_id
)
VALUES
(
   (select LAST_ID +1  from adm.oid where table_name = 'adm.ibm_report'),
   (select date(value) from adm.control where name = 'DB_CREATION'),
   (select date(value) from adm.customer_control where name = 'LATEST_REPORT_GENERATION_DATE'),
   1,
   (select value from adm.control where name = 'DATABASE_VERSION'),
   n.id
);
update adm.oid set last_id = last_id +1 where table_name = 'adm.ibm_report'; end if
%

drop procedure ADM.RPRT_GAPS%
drop procedure ADM.RPRT_GEN%
drop procedure ADM.DROP_IF_EXISTS%

disconnect current%